% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PlotTree.R
\name{PlotTree}
\alias{PlotTree}
\title{Plot the cluster tree}
\usage{
PlotTree(tree, color = "gray90")
}
\arguments{
\item{tree}{a \code{clustertree} object}

\item{color}{nodes color}
}
\description{
Plot the structure of a \code{clustertree} object
}
\details{
Plot the structure of \code{clustertree} object, with the nodes labeled by corresponding
elimination node. The circles represent continuous clusters, while the boxes represent discrete clusters.
}
\examples{
data(toytree)
PlotTree(toytree)

}
\author{
Han Yu
}
\references{
Cowell, R. G. (2005). Local propagation in conditional Gaussian Bayesian networks. 
Journal of Machine Learning Research, 6(Sep), 1517-1550.
}
\seealso{
\code{\link{clustertree}}
}

